Index: libs/python/example/tutorial/Jamroot
===================================================================
--- libs/python/example/tutorial/Jamroot	(.../trunk)	(revision 85881)
+++ libs/python/example/tutorial/Jamroot	(.../branches/modular-build)	(revision 85973)
@@ -20,7 +20,10 @@
 # boost_python library from the project whose global ID is
 # /boost/python.
 project
-  : requirements <library>/boost/python//boost_python ;
+  : requirements <library>/boost/python//boost_python 
+                 <implicit-dependency>/boost//headers 
+  : usage-requirements <implicit-dependency>/boost//headers 
+  ;
 
 # Declare the three extension modules.  You can specify multiple
 # source files after the colon separated by spaces.
Index: libs/python/example/quickstart/Jamroot
===================================================================
--- libs/python/example/quickstart/Jamroot	(.../trunk)	(revision 85881)
+++ libs/python/example/quickstart/Jamroot	(.../branches/modular-build)	(revision 85973)
@@ -12,6 +12,8 @@
 # /boost/python.
 project boost-python-quickstart
   : requirements <library>/boost/python//boost_python 
+    		 <implicit-dependency>/boost//headers 
+  : usage-requirements <implicit-dependency>/boost//headers 	 
     ;
 
 # Make the definition of the python-extension rule available
Index: libs/python/example/Jamroot
===================================================================
--- libs/python/example/Jamroot	(.../trunk)	(revision 85881)
+++ libs/python/example/Jamroot	(.../branches/modular-build)	(revision 85973)
@@ -11,7 +11,10 @@
 # boost_python library from the project whose global ID is
 # /boost/python.
 project
-  : requirements <library>/boost/python//boost_python ;
+  : requirements <library>/boost/python//boost_python 
+                 <implicit-dependency>/boost//headers 
+  : usage-requirements <implicit-dependency>/boost//headers 
+  ;
 
 # Declare the three extension modules.  You can specify multiple
 # source files after the colon separated by spaces.
Index: libs/numeric/odeint/examples/vexcl/Jamfile.v2
===================================================================
--- libs/numeric/odeint/examples/vexcl/Jamfile.v2	(.../trunk)	(revision 85881)
+++ libs/numeric/odeint/examples/vexcl/Jamfile.v2	(.../branches/modular-build)	(revision 85973)
@@ -21,7 +21,7 @@
 lib opencl : : <name>OpenCL ;
 
 project : requirements
-        <library>/boost//headers
+        <implicit-dependency>/boost//headers
         <include>../../../../..
         <include>$(VEXCL_INCLUDE)
         <include>$(CUDA_INCLUDE)
Index: libs/signals2/example/Jamfile.v2
===================================================================
--- libs/signals2/example/Jamfile.v2	(.../trunk)	(revision 85881)
+++ libs/signals2/example/Jamfile.v2	(.../branches/modular-build)	(revision 85973)
@@ -8,7 +8,7 @@
 
 # For more information, see http://www.boost.org
 
-project : requirements <source>/boost//headers ;
+project : requirements <implicit-dependency>/boost//headers ;
 
 exe hello_world_slot : hello_world_slot.cpp ;
 
Index: libs/units/test/Jamfile.v2
===================================================================
--- libs/units/test/Jamfile.v2	(.../trunk)	(revision 85881)
+++ libs/units/test/Jamfile.v2	(.../branches/modular-build)	(revision 85973)
@@ -16,7 +16,7 @@
 
 project boost/units/test :
     requirements
-        <source>/boost//headers
+        <implicit-dependency>/boost//headers
         <include>../../..
         <toolset>msvc:<asynch-exceptions>on
         $(warning-compilers):$(warning-options)
Index: libs/parameter/doc/html/index.html
===================================================================
--- libs/parameter/doc/html/index.html	(.../trunk)	(revision 85881)
+++ libs/parameter/doc/html/index.html	(.../branches/modular-build)	(revision 85973)
@@ -37,7 +37,7 @@
 </tbody>
 </table>
 <!-- @jam_prefix.append('''
-project test : requirements <include>. <source>/boost//headers ;''') -->
+project test : requirements <include>. <implicit-dependency>/boost//headers ;''') -->
 <!-- @example.prepend('''
 #include <boost/parameter.hpp>
 
Index: libs/parameter/doc/index.rst
===================================================================
--- libs/parameter/doc/index.rst	(.../trunk)	(revision 85881)
+++ libs/parameter/doc/index.rst	(.../branches/modular-build)	(revision 85973)
@@ -30,7 +30,7 @@
   can be deduced from their types.
 
 .. @jam_prefix.append('''
-        project test : requirements <include>. <source>/boost//headers ;''')
+        project test : requirements <include>. <implicit-dependency>/boost//headers ;''')
 
 .. @example.prepend('''
    #include <boost/parameter.hpp>
Index: libs/geometry/index/example/Jamfile.v2
===================================================================
--- libs/geometry/index/example/Jamfile.v2	(.../trunk)	(revision 85881)
+++ libs/geometry/index/example/Jamfile.v2	(.../branches/modular-build)	(revision 85973)
@@ -18,7 +18,7 @@
 
 project boost-geometry-index-example
     : requirements
-        <source>/boost//headers
+        <implicit-dependency>/boost//headers
     ;
 
 local GLUT_ROOT = [ os.environ GLUT_ROOT ] ;
Index: libs/predef/test/build.jam
===================================================================
--- libs/predef/test/build.jam	(.../trunk)	(revision 85881)
+++ libs/predef/test/build.jam	(.../branches/modular-build)	(revision 85973)
@@ -4,19 +4,34 @@
 # (See accompanying file LICENSE_1_0.txt or copy at
 # http://www.boost.org/LICENSE_1_0.txt)
 
+local predef-include-root ;
+local predef-dependency ;
+
+# When using modular layout, header files are not present in $root/boost
+# unlink links are created, therefore instead of direct dependency on
+# a header, we need to use dependency on metatarget.
 if $(BOOST_PREDEF_ROOT)
 {
-    path-constant BOOST_PREDEF_INCLUDE_ROOT : $(BOOST_PREDEF_ROOT)/include ;
+    predef-include-root = $(BOOST_PREDEF_ROOT)/include ;
+    predef-dependency = $(predef-include-root)/boost/predef.h ;
 }
+else if $(BOOST_MODULARLAYOUT)
+{
+    predef-include-root = $(BOOST_ROOT)/include ;
+    predef-dependency = /boost//predef-headers ;
+}
 else
 {
-    path-constant BOOST_PREDEF_INCLUDE_ROOT : $(BOOST_ROOT) ;
+   predef-include-root = $(BOOST_ROOT) ;
+   predef-dependency = $(predef-include-root)/boost/predef.h ;         
 }
 
 project test
     :   requirements
-        <include>$(BOOST_PREDEF_INCLUDE_ROOT)
-        <dependency>$(BOOST_PREDEF_INCLUDE_ROOT)/boost/predef.h
+        <include>$(predef-include-root)
+        # Add explicit dependency since we don't have header scanner for
+        # .m and .mm files.
+        <dependency>$(predef-dependency)
     ;
 
 using testing ;
Index: libs/spirit/example/qi/json/build/Jamfile
===================================================================
--- libs/spirit/example/qi/json/build/Jamfile	(.../trunk)	(revision 85881)
+++ libs/spirit/example/qi/json/build/Jamfile	(.../branches/modular-build)	(revision 85973)
@@ -24,8 +24,8 @@
 
 
 lib json
-   : [ glob ../src/*.cpp ]
-          /boost//headers
+   : [ glob ../src/*.cpp ] : 
+          <implicit-dependency>/boost//headers
         :
    :
    : <include>..
Index: tools/regression/build/Jamroot.jam
===================================================================
--- tools/regression/build/Jamroot.jam	(.../trunk)	(revision 85881)
+++ tools/regression/build/Jamroot.jam	(.../branches/modular-build)	(revision 85973)
@@ -37,7 +37,7 @@
     :
     <define>BOOST_ALL_NO_LIB=1
     <define>_CRT_SECURE_NO_WARNINGS
-    <use>/boost//headers
+    <implicit-dependency>/boost//headers
     :
     release
     ;
@@ -51,7 +51,7 @@
     :
     <define>BOOST_ALL_NO_LIB=1
     <define>_CRT_SECURE_NO_WARNINGS
-    <use>/boost//headers
+    <implicit-dependency>/boost//headers
     :
     release
     ;
@@ -64,7 +64,7 @@
     /boost/filesystem//boost_filesystem/<link>static
     :
     <define>BOOST_ALL_NO_LIB=1
-    <use>/boost//headers
+    <implicit-dependency>/boost//headers
     :
     release
     ;
@@ -77,7 +77,7 @@
     /boost/filesystem//boost_filesystem/<link>static
     :
     <define>BOOST_ALL_NO_LIB=1
-    <use>/boost//headers
+    <implicit-dependency>/boost//headers
     :
     release
     ;
@@ -94,7 +94,7 @@
     /boost//iostreams/<link>static
     :
     <define>BOOST_ALL_NO_LIB=1
-    <use>/boost//headers
+    <implicit-dependency>/boost//headers
     :
     release
     ;
Index: tools/Jamfile.v2
===================================================================
--- tools/Jamfile.v2	(.../trunk)	(revision 85881)
+++ tools/Jamfile.v2	(.../branches/modular-build)	(revision 85973)
@@ -12,6 +12,9 @@
     :
     requirements
     <link>static
+    <implicit-dependency>/boost//headers 
+    : 
+    usage-requirements <implicit-dependency>/boost//headers 
     ;
 
 use-project /boost/regression : regression/build ;
Index: Jamroot
===================================================================
--- Jamroot	(.../trunk)	(revision 85881)
+++ Jamroot	(.../branches/modular-build)	(revision 85973)
@@ -128,6 +128,7 @@
 import xsltproc ;
 import set ;
 import path ;
+import link ;
 
 path-constant BOOST_ROOT : . ;
 constant BOOST_VERSION : 1.55.0 ;
@@ -135,6 +136,34 @@
 
 boostcpp.set-version $(BOOST_VERSION) ;
 
+	
+local all-headers =
+    [ MATCH .*libs/(.*)/include/boost : [ glob libs/*/include/boost ] ] ;
+
+for dir in $(all-headers)
+{
+    link-directory $(dir)-headers : libs/$(dir)/include/boost : <location>. ;
+    explicit $(dir)-headers ;
+}
+
+local numeric-headers =
+   [ MATCH .*libs/numeric/(.*)/include/boost : [ glob libs/*/*/include/boost ] ] ;
+
+for dir in $(numeric-headers)
+{
+    link-directory numeric-$(dir)-headers : libs/numeric/$(dir)/include/boost : <location>. ;
+    explicit numeric-$(dir)-headers ;
+}
+
+if $(all-headers)
+{
+    constant BOOST_MODULARLAYOUT : $(all-headers) $(numeric-headers) ;
+}
+if $(BOOST_MODULARLAYOUT)
+{
+    echo modularized layout build ;
+}
+
 project boost
     : requirements <include>.
       # Disable auto-linking for all targets here, primarily because it caused
@@ -210,7 +239,7 @@
     }
 }
 
-alias headers : : : : <include>. ;
+alias headers : $(all-headers)-headers numeric-$(numeric-headers)-headers : : : <include>.  ;
 explicit headers ;
 
 # Make project ids of all libraries known.
